unit TableCellMgr;

interface

uses Windows, Classes, SysUtils, BaseMgrs, TableCells, TableTypes,
WinUtils,TableFunc,BaseObjs;

type

  TCellMgr = class(TBaseMgr)
  private

  protected

    function GetCell(Idx: LongInt): TCell;
    function GetCellCR(C, R: LongInt): TCell;
    function GetCellCRStr(C,R: string): TCell;
    function GetCellName(AName: string): TCell;

    procedure SetCell(Idx: LongInt; Value: TCell);
    procedure SetCellCR(C, R: LongInt; Value: TCell);
    procedure SetCellCRStr(C, R: string; Value: TCell);
    procedure SetCellName(AName: string; Value: TCell);

  public
    constructor Create(Owns: boolean = true); override;
    destructor Destroy; override;

    function Add(Col, Row: LOngInt; Text: string; Content: TCellContent =
      ccText): TCell; reintroduce; overload;
    function Add(Cell: TCell): TCell; reintroduce; overload;

    property CellsIdx[Index: LongInt]: TCell read GetCell write SetCell;
    property CellsPos[Col, Row: LongInt]: TCell read GetCellCR write SetCellCR;default;
    property CellsPosStr[Col, Row: string]: TCell read GetCellCRStr write SetCellCRStr;
    property CellsName[Name: string]: TCell read GetCellName write SetCellName;

  published

  end;



implementation

constructor TCellMgr.Create(Owns: boolean = true);
begin
  inherited Create(Owns);

end;

destructor TCellMgr.Destroy;
begin


  inherited Destroy;
end;

function TCellMgr.GetCell(Idx: LongInt): TCell;
begin
 Result:=TCell(Objects[Idx]);
end;

function TCellMgr.GetCellCR(C, R: LongInt): TCell;
var I:LongInt;
    P:TCellPos;
begin
 Result:=nil;
 P:=CellPos(C,R);
 for I:=0 to Count - 1 do
  if SamePos(CellsIdx[I].Pos,P) then
   Result:=CellsIdx[I];
end;

function TCellMgr.GetCellCRStr(C,R: string): TCell;
begin

end;

function TCellMgr.GetCellName(AName: string): TCell;
var I:LongInt;
begin
 Result:=nil;
 for I:=0 to Count - 1 do
  if CellsIdx[I].Name=AName then
   Result:=CellsIdx[I];
end;

procedure TCellMgr.SetCell(Idx: LongInt; Value: TCell);
begin

end;

procedure TCellMgr.SetCellCR(C, R: LongInt; Value: TCell);
begin

end;

procedure TCellMgr.SetCellCRStr(C, R: string; Value: TCell);
begin

end;

procedure TCellMgr.SetCellName(AName: string; Value: TCell);
begin

end;


function TCellMgr.Add(Col, Row: LongInt; Text: string; Content: TCellContent): TCell;
var C:TCell;
begin
 C:=TCell.Create;
 C.Pos:=CellPos(Col,Row);
 C.Name:=Text;
 C.Content:=Content;
 Result:=Add(C);
end;

function TCellMgr.Add(Cell: TCell): TCell;
begin
 Result:=TCell( inherited Add(TBaseObj(Cell)));
end;



end.

