unit TableStyles;

interface

uses Windows,Classes,SysUtils,TableTypes,BaseObjs,Colors,Graphics;

type

   TTableStyle=class(TPersistent)
                private
                 FOwner:TBaseObj;
                 FSaveStyle:boolean;
                 FUseStyle:boolean;
                 FShowRowHeader:boolean;
                 FShowColHeader:boolean;
                 FRowHeaderStyle:THeaderStyle;
                 FColHeaderStyle:THeaderStyle;
                 FDefaultStyle:TCellStyle;

                protected

                public

                 constructor Create(AOwner:TBaseObj);
                 destructor Destroy;override;

                published

                  property UseStyle:boolean read FSaveStyle write FSaveStyle;
                  property SaveStyle:boolean read FSaveStyle write FSaveStyle;
                  property ShowColHeader:boolean read FShowColHeader write FShowColHeader;
                  property ShowRowHeader:boolean read FShowRowHeader write FShowRowHeader;
                  property ColHeaderStyle:THeaderStyle read FColHeaderStyle write FColHeaderStyle;
                  property RowHeaderStyle:THeaderStyle read FRowHeaderStyle write FRowHeaderStyle;
                  property DefaultStyle:TCellStyle read FDefaultStyle write FDefaultStyle;


                end;





implementation

constructor TTableStyle.Create(AOwner:TBaseObj);
begin
 inherited Create;
 FOwner:=AOwner;
 FUseStyle:=true;
 FSaveStyle:=true;
 FShowColHeader:=true;
 FShowRowHeader:=true;

 FColHeaderStyle.FontName:='Arial';
 FColHeaderStyle.FontSize:=10;
 FColHeaderStyle.FontColor:=colWhite;
 FColHeaderStyle.FontStyle:=[fsBold];
 FColHeaderStyle.BackColor:=colNavy;
 FColHeaderStyle.FrameWidth:=1;
 FColHeaderStyle.Options:=[coCenter];

 FRowHeaderStyle.FontName:='Arial';
 FRowHeaderStyle.FontSize:=10;
 FRowHeaderStyle.FontColor:=colWhite;
 FRowHeaderStyle.FontStyle:=[fsBold];
 FRowHeaderStyle.BackColor:=colNavy;
 FRowHeaderStyle.FrameWidth:=1;
 FRowHeaderStyle.Options:=[coCenter];

 FDefaultStyle.FontName:='Arial';
 FDefaultStyle.FontSize:=10;
 FDefaultStyle.FontColor:=colBlack;
 FDefaultStyle.FontStyle:=[];
 FDefaultStyle.BackColor:=colWhite;
 FDefaultStyle.FrameWidth:=1;
 FDefaultStyle.Options:=[coLeft];


end;

destructor TTableStyle.Destroy;
begin

 inherited Destroy;
end;



end.
