unit Engines;

interface

uses
Windows,Classes,SysUtils,BaseObjs,Timers,BaseMgrs;


type


    TEngine=class(TBaseObj)
            private
             FDescription:string;
             FObjects:TBaseMgr;
             FOwner:TEngine;
             FTimer:TTimer;



            protected
              procedure SetObjects(Value:TBaseMgr);

              procedure OnTimerEvent(Sender:TObject);virtual;
              procedure SetWithoutOwner;virtual;

            public
              constructor Create(AOwner:TEngine=nil);reintroduce;virtual;
              destructor Destroy;override;

              procedure Init;override;
              procedure Done;override;
              procedure Update;override;
              procedure TryUpdate(Time:LongInt=0);override;

              property Objects:TBaseMgr read FObjects write SetObjects;
              property Owner:TEngine read FOwner write FOwner;
              property Timer:TTimer read FTimer write FTimer;

            published


             property Description:string read FDescription write FDescription;
            end;




implementation

constructor TEngine.Create(AOwner:TEngine);
begin
 inherited Create;
 FOwner:=AOwner;
 UpdatePeriod:=-1;
 Name:='Base Engine';
 FObjects:=TBaseMgr.Create;

 if FOwner=nil then
  SetWithoutOwner;



end;

procedure TEngine.SetWithoutOwner;
begin
 FTimer:=TTimer.Create(nil);
 FTimer.Interval:=100;
 FTimer.OnTimer:=OnTimerEvent;

end;

procedure TEngine.OnTimerEvent(Sender:TObject);
begin
 TryUpdate;
end;

destructor TEngine.Destroy;
begin

  FTimer.Free;
  FObjects.Free;
  inherited Destroy;
end;

procedure TEngine.Init;
begin


 inherited Init;
 if FTimer<>nil then FTimer.Enabled:=true;
end;

procedure TEngine.Done;
begin
 inherited Done;
 if FTimer<>nil then FTimer.Enabled:=false;


end;


procedure TEngine.Update;
begin
 inherited Update;

end;


procedure TEngine.TryUpdate(Time:LongInt);
begin
  inherited TryUpdate(Time);

end;

procedure TEngine.SetObjects(Value:TBaseMgr);
begin
 FObjects:=Value;
end;

end.
