unit MainEngine;

interface

uses
 Windows,Classes,SysUtils,BaseObjs,Engines,Timers;

type

 TMainEngine=class(TEngine)
 private

 protected
  procedure SetEngine(idx:LongInt;Value:TEngine);
  function GetEngine(idx:LongInt):TEngine;

 public
  constructor Create(AOwner:TEngine=nil);override;
  destructor Destroy;override;

  procedure Init;override;
  procedure Update;override;
  procedure TryUpdate(Time:LongInt);override;

  function Add(Engine:TEngine):LongInt;virtual;
  property Engines[Index:LongInt]:TEngine read GetEngine write SetEngine;


 published

 end;



implementation


constructor TMainEngine.Create(AOwner:TEngine);
begin
 inherited Create(AOwner);
 Name:='Main Engine';
 UpdatePeriod:=-1;
end;

destructor TMainEngine.Destroy;
begin

  inherited Destroy;
end;

procedure TMainEngine.Init;
var I:LongInt;
begin
 inherited Init;

 for I:=0 to Objects.Count-1 do
  Engines[I].Init;

end;

procedure TMainEngine.Update;
begin
 inherited Update;

end;


procedure TMainEngine.TryUpdate(Time:LongInt);
begin
  inherited TryUpdate(Time);

end;

procedure TMainEngine.SetEngine(idx:LongInt;Value:TEngine);
begin
 if idx in [0..Objects.Count-1]then
 Objects[idx]:=Value;
end;

function TMainEngine.GetEngine(idx:LongInt):TEngine;
begin
 Result:=nil;
 if idx in [0..Objects.Count-1]then
 Result:=TEngine(Objects[idx]);
end;

function TMainEngine.Add(Engine:TEngine):LongInt;
begin
Result:=-1;
if Engine<>nil then
begin
 Result:=Objects.Add(Engine);
 Engine.Owner:=Self;
end;

end;

end.
