unit FileRec;

interface

uses Windows,SysUtils,Classes;


type



   TFileRec=class
          private
           FName:string;
           FMS:TMemoryStream;
           FRef:LongInt;
          protected

           function GetSize:DWord;
           function GetData:Pointer;
           function GetStream:TMemoryStream;
           function GetLoaded:boolean;

          public
           constructor Create(AName:string='');virtual;
           destructor Destroy;override;

           procedure CopyTo(FR:TFileRec);virtual;
           procedure CopyFrom(FR:TFileRec);virtual;
           procedure Clear;

           property Name:string read FName write FName;
           property Size:DWord read GetSize;
           property Data:Pointer read GetData;
           property Stream:TMemoryStream read GetStream;
           property Loaded:boolean read GetLoaded;
           property RefCount:LongInt read FRef write FRef;

          end;


implementation

constructor TFileRec.Create(AName:string);
begin
 inherited Create;
 FName:=AName;
 FMS:=TMemoryStream.Create;

end;

destructor TFileRec.Destroy;
begin
 FMS.Free;
 inherited Destroy;
end;

function TFileRec.GetSize:DWord;
begin
 Result:=0;
 if not Loaded then Exit;
 Result:=FMS.Size;

end;

function TFileRec.GetData:Pointer;
begin
 Result:=nil;
 if not Loaded then Exit;
 Result:=FMS.Memory;

end;

function TFileRec.GetStream:TMemoryStream;
begin
 FMS.Position:=0;
 Result:=FMS;
end;

function TFileRec.GetLoaded:boolean;
begin
 if FMS.Size>0 then Result:=true
 else Result:=false;

end;

procedure TFileRec.CopyTo(FR:TFileRec);
begin
 if FR=nil then Exit;
 if not Loaded then
  raise Exception.Create('TFileRec.CopyTo  -  Source is empty');
 FR.CopyFrom(Self);

end;

procedure TFileRec.CopyFrom(FR:TFileRec);
begin
 if FR=nil then Exit;
 if not FR.Loaded then
  raise Exception.Create('TFileRec.CopyFrom  -  Source is empty');


 FMS.LoadFromStream(FR.FMS);
 FName:=FR.FName;

end;

procedure TFileRec.Clear;
begin
FMS.Clear;
Name:='';
end;


end.
