unit CharMgrs;

interface

uses Windows,SysUtils,Classes,WinUtils,BaseObjs,Objs3D,Types3D,
     Utils3D,Colors,Textures,BaseMgrs,Chars;

type

   TCharMgr=class(TBaseMgr)
           private

           protected

            function GetChar(Idx:LongInt):TChar;
            function GetCharName(AName:char):TChar;

           public

             function FreeImages:LongInt;  // returns count of freed images
             function FreeDevTextures:LongInt;  // returns count of freed dev textures
             function InitDevTextures:LongInt;  // returns count of initedd dev textures

             property Char[Index:LongInt]:TChar read GetChar;
             property CharName[AName:char]:TChar read GetCharName;default;

            end;

implementation

function TCharMgr.GetChar(Idx:LongInt):TChar;
begin
 Result:=TChar(Objects[Idx]);
end;

function TCharMgr.GetCharName(AName:char):TChar;
var I:LongInt;
begin
Result:=nil;
 for I:=0 to Count-1 do
  if AName=TChar(ObjectList[I]).Character then
   begin
    Result:=TChar(ObjectList[I]);
    Exit;
   end;

end;

function TCharMgr.FreeImages:LongInt;
var I:LongInt;
begin
 Result:=0;
 for I:=0 to Count-1 do
  if Char[I].Texture.Image<>nil then
   begin
   Char[I].Texture.Image:=nil;
   Inc(Result);
   end;
end;

function TCharMgr.FreeDevTextures:LongInt;
var I:LongInt;
begin
Result:=0;
 for I:=0 to Count-1 do
  if Char[I].Texture.Inited then
   begin
   Char[I].Texture.Done;
   Inc(Result);
   end;
end;

function TCharMgr.InitDevTextures:LongInt;
var I:LongInt;
begin
Result:=0;
if Count=0 then
 raise Exception.Create('TCharMgr.InitDevTextures  -  Character count = 0');

 for I:=0 to Count-1 do
  if Char[I].Texture.Image<>nil then
   begin
   Char[I].Init;
   Inc(Result);
   end;
end;



end.
