unit Chars;

interface

uses Windows, SysUtils, Classes, WinUtils, BaseObjs, Objs3D, Types3D,
  Utils3D, Colors, Textures, BaseMgrs,FontTypes,Images;

type

  TChar = class(TBaseObj)
  public
    Character: Char;
    Texture: TTexture;
    Width:LongInt;

    constructor Create(AChar:Char); reintroduce;
    destructor Destroy; override;

    procedure Init; override;
    procedure Done; override;

  end;

implementation

constructor TChar.Create(AChar:Char);
begin
 inherited Create;
 Character:=AChar;
 Texture:=TTexture.Create;
 Texture.UseMipMaps:=false;
 Texture.ClearAfterInit:=false;
 Texture.DevTexBits:=CharTexBits;
 Texture.Detail:=1;
 Texture.Image.Format:=FindFormat('.tga');
end;

destructor TChar.Destroy;
begin
 Texture.Free;
 inherited Destroy;
end;

procedure TChar.Init;
begin
 Texture.Init;
 inherited Init;
end;

procedure TChar.Done;
begin
 inherited Done;
 Texture.Done;

end;

end.

