unit FontTypes;

interface

uses Windows, Classes, SysUtils, Colors, GfxTypes;



// characters
type
  TFontChars = string;

  TFontStyle = (fsBold, fsItalic, fsUnderLine, fsStrikeOut,
    fsOutlined, fsOutlineOnly, fsNoAntiAlias,fsFreeImages);
  TFontStyles = set of TFontStyle;


  // for TFont.RenderTextFX
  TFXType = (fxBlend, fxRotate, fxFlip, fxStretch,fxAlpha,fxShadow);

  TFXTypes = set of TFXType;

  TFontFX = record
    FX: TFXTypes;

//  fxBlend:
    SrcBlend,
      DestBlend: TSetDWordValue;
//  fxRotate:
    Angle: single; //in degrees;
//  fxFlip:     flips only char tex coords
    FlipX,
      FlipY: boolean;
//  fxStretch:
    StretchX, // 1.1 = 110 percent of original
      StretchY: single;
//  fxAlpha
    Alpha:byte;
//  fxShadow
    SOffsetX:single;
    SOffsetY:single;
    SColor:TARGB;
    
  end;


const

  sCharsNumbers = '0123456789';
  sCharsSmall = 'abcdefghijklmnopqrstuvwxyz';
  sCharsBig = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  sCharsSymbols = '+-*/\|^~!@#$%&*()[]{}<>_;'',.?:"=`'#32;
  sCharsSpecial = '??';
  sCharsSmallCzech = '';
  sCharsBigCzech = '̊؎ٍ';
  sCharsSymbolsCzech = '';


const

  sCharsStdFont: TFontChars = sCharsNumbers + sCharsSmall + sCharsBig +
  sCharsSymbols + sCharsSpecial;
  sCharsCzechFont: TFontChars = sCharsNumbers + sCharsSmall + sCharsBig +
  sCharsSymbols + sCharsSpecial + sCharsSmallCzech + sCharsBigCzech +
    sCharsSymbolsCzech;

const
 // separates chars in bitmap fonts
  CharSeparatorCol: TARGB = $FFFF00FF;


// default settings
var
  CharTexBits: LongInt = 16; // bitcount of char texture
  CharTexSize: LongInt = 32; // size of texture for each char

  DefaultCharSet: TFontChars;
  ACharSet: TFontChars;

  CharSets:array of TFontChars;

type

  EFontError = class(Exception)
  end;


implementation

initialization

  DefaultCharSet := sCharsCzechFont;
  ACharSet := DefaultCharSet;


  SetLength(CharSets,2);
  CharSets[0]:=sCharsStdFont;
  CharSets[1]:=sCharsCzechFont;

finalization

end.

