unit GGraphic;

interface

uses GraphicEngine,Renderers,ViewPorts,Cameras,TextureMgrs,Engines;



function Graphic:TGraphicEngine;
function Renderer:TRenderer;
function ViewPort:TViewPort;
function Camera:TCamera;
function TextureMgr:TTextureMgr;
procedure CreateGraphic(AHandle:THandle=0;AOwner:TEngine=nil);
procedure CreateAndInitGraphic(AHandle:THandle=0;AOwner:TEngine=nil);


implementation


function Graphic:TGraphicEngine;
begin
 Result:=TGraphicEngine.GetInstance;
end;

function Renderer:TRenderer;
begin
 Result:=TGraphicEngine.GetInstance.ActiveRenderer;
end;

function ViewPort:TViewPort;
begin
 Result:=TGraphicEngine.GetInstance.ViewPort;
end;

function Camera:TCamera;
begin
 Result:=TGraphicEngine.GetInstance.Camera;
end;

function TextureMgr:TTextureMgr;
begin
 Result:=TGraphicEngine.GetInstance.TextureMgr;
end;

procedure CreateGraphic(AHandle:THandle;AOwner:TEngine);
begin
 TGraphicEngine.Create(AHandle,AOwner);
end;

procedure CreateAndInitGraphic(AHandle:THandle=0;AOwner:TEngine=nil);
begin
 TGraphicEngine.Create(AHandle,AOwner).Init;
end;



end.
