unit D3DMisc;

interface

uses Windows,DirectXGraphics,DXGUtils,Types3D,Colors,Classes,Lights;

type

  IDevice=IDirect3DDevice8;
  ID3D=IDirect3D8;
  ITexture=IDirect3DTexture8;
  IVBuffer=IDirect3DVertexBuffer8;
  IIBuffer=IDirect3DIndexBuffer8;
  ISurf=IDirect3DSurface8;
  IBaseTex=IDirect3DBaseTexture8;
  IResource=IDirect3DResource8;
  ISwapChain=IDirect3DSwapChain8;


  TAdapterID=TD3DAdapterIdentifier8;
  TDevCreateParams=TD3DDeviceCreationParameters;
  TD3DPP=TD3DPresentParameters;
  TD3DLight=TD3DLight8;
  TD3DMat=TD3DMaterial8;
  TD3DView=TD3DViewPort8;

type

  TDisplayMode = class
    Width: Dword;
    Height: Dword;
    Format: TD3DFormat;
    Refresh: Dword;
  end;

  TVPNC1T1=record
                  Pos:TPoint3S;
                  Normal:TPoint3S;
                  Color1:DWord;
                  Coord1:TTexCoord;
                 end;

  TVPC1T1=record
                  Pos:TPoint3S;
                  Color1:DWord;
                  Coord1:TTexCoord;
              end;

  TVPC1=record
                  Pos:TPoint3S;
                  Color1:DWord;
              end;


  TVPC1T2=record
                  Pos:TPoint3S;
                  Color1:DWord;
                  Coord1:TTexCoord;
                  Coord2:TTexCoord;

              end;


  TVPC2T1=record
                  Pos:TPoint3S;
                  Color1:DWord;
                  Color2:DWord;
                  Coord1:TTexCoord;

              end;

   TVPC2T2=record
                  Pos:TPoint3S;
                  Color1:DWord;
                  Color2:DWord;
                  Coord1:TTexCoord;
                  Coord2:TTexCoord;

              end;

   TVPNC2T2=record
                Pos:TPoint3S;
                Normal:TPoint3S;
                Color1:DWord;
                Color2:DWord;
                Coord1:TTexCoord;
                Coord2:TTexCoord;

              end;

   TVPNC2T1=record
                Pos:TPoint3S;
                Normal:TPoint3S;
                Color1:DWord;
                Color2:DWord;
                Coord1:TTexCoord;
                Coord2:TTexCoord;

              end;


const
 FVF_PNC1T1= D3DFVF_XYZ  or  D3DFVF_NORMAL or  D3DFVF_DIFFUSE or  D3DFVF_TEX1;
 FVF_PC1= D3DFVF_XYZ  or  D3DFVF_DIFFUSE;
 FVF_PC1T1= D3DFVF_XYZ  or  D3DFVF_DIFFUSE or  D3DFVF_TEX1;
 FVF_PC2T2= D3DFVF_XYZ  or  D3DFVF_DIFFUSE or D3DFVF_SPECULAR or  D3DFVF_TEX1 or D3DFVF_TEX2;
 FVF_PC1T2= D3DFVF_XYZ  or  D3DFVF_DIFFUSE or  D3DFVF_TEX1 or D3DFVF_TEX2;
 FVF_PC2T1= D3DFVF_XYZ  or  D3DFVF_DIFFUSE or D3DFVF_SPECULAR or  D3DFVF_TEX1;
 FVF_PNC2T2= D3DFVF_XYZ  or  D3DFVF_NORMAL or  D3DFVF_DIFFUSE or D3DFVF_SPECULAR or  D3DFVF_TEX1 or D3DFVF_TEX2;
 FVF_PNC2T1= D3DFVF_XYZ  or  D3DFVF_NORMAL or  D3DFVF_DIFFUSE or  D3DFVF_TEX1;

type

  TD3DBuffer=record
              VBuff:IVBuffer;
              Mode:DWord;
              Stride:DWord;
              FVF:DWord;
             end;
  PD3DBuffer=^TD3DBuffer;

  TD3DBuffer2=record
              Vertices:Pointer;
              Mode:DWord;
              Stride:DWord;
              FVF:DWord;
             end;
  PD3DBuffer2=^TD3DBuffer2;



  TD3DTex=record
           ITex:ITexture;
          end;
  PD3DTex=^TD3DTex;

procedure CreateOrthoMatrix(var Mat:TD3DMatrix;Width,Height:single);
function VertexNorm(X,Y,Z,nX,nY,nZ:single;Col:DWord;U,V:single):TVPNC1T1;
function Vertex(X,Y,Z:single;Col:DWord;U,V:single):TVPC1T1;
function ViewPort(X,Y,W,H:LOngInt;MinZ,MaxZ:single):TD3DView;
function FloatToDword(f:single):dword;
function LCToD3DLC(C:TLightColor):TD3DColorValue;
function Point3SToD3DV(P:TPoint3S):TD3DVector;

implementation

// for SetRenderState  - FogStart,FogEnd,FogDensity,...
function FloatToDword(f:single):dword;
var ps:^Single;
 begin
  New(ps);
  ps^:=f;
  Result:=pdword(ps)^;
  Dispose(ps);
 end;

procedure CreateOrthoMatrix(var Mat:TD3DMatrix;Width,Height:single);
begin

DXGUtils.SetIdentityMatrix(Mat);

Mat._11:=2/Width;
Mat._22:=-2/Height;
Mat._33:=0.5;
Mat._41:=-1;
Mat._42:=1;
Mat._43:=0.5;
Mat._44:=1;

//Similar to  D3DXMatrixOrthoOffCenterLH(Mat,0,Width,Height,0,-1,1);
// Point [0,0] is in top-left of screen

end;


function VertexNorm(X,Y,Z,nX,nY,nZ:single;Col:DWord;U,V:single):TVPNC1T1;
begin
 Result.Pos.X:=X;
 Result.Pos.Y:=Y;
 Result.Pos.Z:=Z;
 Result.Normal.X:=nX;
 Result.Normal.Y:=nY;
 Result.Normal.Z:=nZ;
 Result.Color1:=Col;
 Result.Coord1.X:=U;
 Result.Coord1.Y:=V;

end;

function Vertex(X,Y,Z:single;Col:DWord;U,V:single):TVPC1T1;
begin
 Result.Pos.X:=X;
 Result.Pos.Y:=Y;
 Result.Pos.Z:=Z;
 Result.Color1:=Col;
 Result.Coord1.X:=U;
 Result.Coord1.Y:=V;

end;

function ViewPort(X,Y,W,H:LOngInt;MinZ,MaxZ:single):TD3DView;
begin
 Result.X:=X;
 Result.Y:=Y;
 Result.Width:=W;
 Result.Height:=H;
 Result.MinZ:=MinZ;
 Result.MaxZ:=MaxZ;
end;


function LCToD3DLC(C:TLightColor):TD3DColorValue;
begin
Result.A:=1;
Result.R:=C.R;
Result.G:=C.G;
Result.B:=C.B;
end;

function Point3SToD3DV(P:TPoint3S):TD3DVector;
begin
Result.x:=P.X;
Result.y:=P.Y;
Result.z:=P.Z;
end;




end.
