unit DrawingEngines;

interface

uses Windows, Classes, SysUtils, WinUtils, Engines, 
  BaseMgrs, GraphicEngine;

type

  TDrawingEngine = class(TEngine)
  private

  protected
    procedure SetOrder(Value: LongInt); override;

  public
    constructor Create(AOwner: TEngine); override;
    destructor Destroy; override;

    procedure Draw; virtual;
    procedure DrawStats; virtual;



  published

  end;

  TDrawingEngineClass = class of TDrawingEngine;


  TDrawingEnginesMgr = class(TSortedMgr)
  private

  public

  end;



var
  DrawingEnginesMgr: TDrawingEnginesMgr;


implementation


constructor TDrawingEngine.Create(AOwner: TEngine);
begin
  inherited Create(AOwner);
  Order := 0; // == does  DrawingEnginesMgr.Add(Self);


end;

destructor TDrawingEngine.Destroy;
begin

  DrawingEnginesMgr.Extract(Self);
  inherited Destroy;
end;

procedure TDrawingEngine.Draw;
begin
end;

procedure TDrawingEngine.DrawStats;
begin

end;

procedure TDrawingEngine.SetOrder(Value: LongInt);
begin
  DrawingEnginesMgr.Extract(Self);
  inherited;
  DrawingEnginesMgr.Add(Self);

end;


initialization

  DrawingEnginesMgr := TDrawingEnginesMgr.Create(false);
  DrawingEnginesMgr.UniqueObjects := false;

finalization

  DrawingEnginesMgr.Free;

end.

