unit GraphicEngine;


  // TODO portal engine basis 
  // TODO multiple graphic engines managing (for editors)
  // TODO 3D modeling enviroment levels&models
  // TODO change ugly TTexture stuff  ,add multitex & animated tex,procedural tex
  // TODO change TREnderer.functionXXX to tRenderer.procedureXXX
  // TODo add STACK to all Pushs and Pops
  // TODO wait for CAL3D >>repair sphere(my own);add height segments to cylinder
  //; add to all GeoObjs ability to move base points,normals
  //; add TBaseMesh - contains geo data;GeoObjs have their own Meshes;Models have shared meshes
  // TODO add Tube,Cone,Pyramid,...
  // TODO TSkyDome
  // TODO add try..except everywhere
  // TODO DynLights Manager
  // TODO useful timers
  // TODO support for plugins *.bpl,*.dll
  // TODO add to fonts - createtexttexture,...
  // TODO complex GUI


interface

uses
  Windows, Classes, SysUtils, Engines, Renderers, GfxWin, BaseObjs,
  GfxTypes, Timers, Timing, WinUtils, Colors, Textures, Types3D,
  DrawBuffers, Utils3D, ViewPorts, Cameras,TextureMgrs,BaseMgrs,Images;

type

  TGraphicEngine = class;


  TOnDrawEvent = procedure(Sender: TGraphicEngine) of object;
  TOnDrawProc=procedure;

  EGEngineErr = class(Exception)
  end;

  TGraphicEngine = class(TEngine)
  private
    FWindow: TGfxWin;
    FHandle: THandle;
    FActiveRen: TRenderer;
    FPreferD3D: boolean;
    FGfxParams: TRenderInitParams;

    FFPS: single;
    FAvgFPS: single;
    FActFPS:single;
    FLastTime: single;
    FFrames: DWord;
    FLastSec: single;
    FRenderStart: single;
    FSecFrames: DWord;

   // projection vars
    FProjMode: TProjMode;
    FOrthoWidth: LongInt;
    FOrthoHeight: LongInt;
    FFov: single;
    FBack: single;
    FPersWidth: single;
    FPersHeight: single;


   ////  events
    FOnFirstDraw: TOnDrawEvent;
    FOnLastDraw: TOnDrawEvent;
    FOnDraw:TOnDrawProc;
    FOnFirstDrawProc:TOnDrawProc;

   // colors
    FAmbient: TARGB;

   // draw buffers
    FBuffer: TDrawBuffer;
    FActBuff: TDrawBuffer;

   //
    FViewPort: TViewPort;
    FCamera: TCamera;
    FTextureMgr:TTextureMgr;

   //
    FClearColor: TARGB;
    FClearZVal: single;
    FAutoClearTarget: boolean;
    FAutoClearZ: boolean;
    FAutoPresent:boolean;

    //
    FModes:TBaseMgr;

    FPushView:TViewPort;
    FPushCam:TCamera;
    FPushFeat:TFeatureSet;
    FPushDWord:TDWordSet;
    FPushFloat:TFloatSet;

    procedure CreateRenderers;
    procedure SetRenParams(ARen: TRenderer);
    procedure SetActiveRenParams;
    procedure NullSets;
    procedure DefaultSets;
    procedure InitSets;
    procedure CheckBuff;
    procedure EnumFullScrModes;

    procedure OnInitReset(MsgID: LongInt; Sender: TBaseObj; Data: Pointer);
    procedure OnWindowFree(MsgID: LongInt; Sender: TBaseObj; Data: Pointer);


  protected
    procedure SetRen(Idx: LongInt; Value: TRenderer); virtual;
    function GetRen(Idx: LongInt): TRenderer; virtual;
    function GetOwn: boolean; virtual;
    function GetRenCount: LongInt; virtual;
    function GetAvgFPS: single; virtual;
    function GetModesCount:LongInt;virtual;
    function GetMode(Idx:LongInt):TFullScreenMode;

    procedure SetWindow(Value: TGfxWin); virtual;
    procedure SetProjMode(Value: TProjMode); virtual;
    procedure SetAmbient(Value: TARGB); virtual;
    procedure SetViewPort(Value: TViewPort); virtual;
    procedure SetCamera(Value: TCamera); virtual;

    procedure OnTimerEvent(Sender: TObject); override;
    procedure SetWithoutOwner; override;
    procedure CalcFPS;

  public
    // if you change this settings ,changes will be made
    // after renderer reset;
    // use SetDWord,Enable,SetFloat instead
    FeatureSet: TFeatureSet;
    DWordSet: TDWordSet;
    FloatSet: TFloatSet;


    constructor Create(AHwnd: THandle = 0; AOwner: TEngine = nil); reintroduce;
    destructor Destroy; override;

    procedure Init; override;
    procedure Done; override;
    procedure Update; override;
    function Reset: boolean; virtual;

    procedure ChangeRenderer(ARen: TREnderer; InitNewRen: boolean = true);
      virtual;
    function GetRenByName(AName: string): TRenderer;


    function Add(Ren: TRenderer): LongInt;


    procedure Draw; virtual;
    procedure DrawStats; virtual;

    procedure StopRendering;
    procedure ResumeRendering;

    // projection
    // default values = use last settings
    procedure SetOrtho(Width: LongInt = 0; Height: LongInt = 0);
    procedure SetPerspective(Back: single = 0; Fov: single = 0); overload;
    procedure SetPerspective(Back: single = 0; Width: single = 0; Height: single
      = 0); overload;


    // features
    procedure Enable(F: TFeature);
    procedure Disable(F: TFeature);
    function IsSet(F: TFeature): boolean;


    // display mode changing
    function ToggleFullScreen: boolean;
    function SetResolution(AWidth, AHeight: LongInt): boolean; overload;
    function SetResolution(AWidth, AHeight, ABits: LongInt; Full: boolean):
      boolean; overload;



    // drawing functions  - depending on active renderer

    function Present: boolean;
    function ClearTarget(Color: TARGB): boolean;
    function ClearZBuffer(Value: single): boolean;

    function RenderPoint(Pos:TPoint3S;Col:TARGB):boolean;
    function RenderLine(P1,P2:TPoint3S;Col:TARGB):boolean;overload;
    function RenderLine(P1,P2:TPoint3S;Col1,Col2:TARGB):boolean;overload;
    function RenderRect(P1,P2:TPoint3S;Col:TARGB;Solid:boolean=true):boolean;overload;
    function RenderRect(X,Y,Width,Height:LongInt;Col:TARGB;Solid:boolean=true;MatchRes:boolean=true):boolean;overload;



    // high level drawing functions - slow
    // MatchResolution Parameter = orthogonal projection is set according to
    //    device resolution
    function RenderImage(X,Y:single;Img:TImage;MatchRes:boolean=true):boolean;overload;
    function RenderImage(X,Y,Width,Height:single;Img:TImage;MatchRes:boolean=true):boolean;overload;
    function RenderTexture(X,Y:single;Tex:TTexture;MatchRes:boolean=true):boolean;overload;
    function RenderTexture(X,Y,Width,Height:single;Tex:TTexture;MatchRes:boolean=true):boolean;overload;



    // draw buffers
    function DrawBegin(Mode: TDrawMode; Buff: TDrawBuffer = nil): boolean;
    // draw vertex must be called after drawcol,nornal,...
    function DrawVertex(vX, vY, vZ: single): boolean; overload;
    function DrawVertex(vP: TPoint3S): boolean; overload;
    function DrawColor1(Color: TARGB): boolean; overload;
    function DrawColor1(cA, cR, cG, cB: byte): boolean; overload;
    function DrawColor1(cRec: TARGBRec): boolean; overload;
    function DrawColor2(Color: TARGB): boolean; overload;
    function DrawColor2(cA, cR, cG, cB: byte): boolean; overload;
    function DrawColor2(cRec: TARGBRec): boolean; overload;
    function DrawNormal(nX, nY, nZ: single): boolean; overload;
    function DrawNormal(nP: TPoint3S): boolean; overload;
    function DrawCoord1(cX, cY: single): boolean; overload;
    function DrawCoord1(cP: TPoint2S): boolean; overload;
    function DrawCoord2(cX, cY: single): boolean; overload;
    function DrawCoord2(cP: TPoint2S): boolean; overload;
    function DrawCount(primcnt: LongInt): boolean;
    function DrawClear(Mode: TClearModes = [cmAll]): boolean;
    function DrawUse(used: TUsedFields): boolean;
    function DrawEnd(immediate: boolean = true): boolean;
    function DrawTexture(Tex: TTexture): boolean;
    function DrawBuffer(Buff: TDrawBuffer = nil): boolean;
    // new
    function DrawPoints(Points: array of TPoint3S): boolean;overload;
    function DrawPoints(Points: array of PPoint3S): boolean;overload;
    function DrawNormals(Norms: array of TPoint3S): boolean;
    function DrawColors1(Cols: array of TARGB): boolean;
    function DrawColors2(Cols: array of TARGB): boolean;
    function DrawCoords1(Coords: array of TTexCoord): boolean;
    function DrawCoords2(Coords: array of TTexCoord): boolean;


    // push/pop operations - only one level for the present
    procedure PushViewPort;
    procedure PushCamera;
    procedure PushFeatures;
    procedure PushDWords;
    procedure PushFloats;

    procedure PopViewPort;
    procedure PopCamera;
    procedure PopFeatures(F:TFeatures);
    procedure PopDWords(D:TDWordModes);
    procedure PopFloats(F:TFloatModes);



    class function GetInstance: TGraphicEngine;

    // props
    property FPS: single read FFPS;
    property ActualFPS:single read FActFPS;
    property AvgFPS: single read GetAvgFPS;
    property FramesRendered: DWord read FFrames;
    property Window: TGfxWin read FWindow write SetWindow;
    property Renderers[Index: LongInt]: TRenderer read GetRen write SetRen;
    property RenCount: LongInt read GetRenCount;
    property ActiveRenderer: TRenderer read FActiveRen;
    property OwnWindow: boolean read GetOwn;
    property GfxParams: TRenderInitParams read FGfxParams write FGfxParams;

    property ProjMode: TProjMode read FProjMode write SetProjMode;
      // setprojmode - use last settings
    property Fov: single read FFov;
    property Back: single read FBack;
    property OrthoWidth: LongInt read FOrthoWidth;
    property OrthoHeight: LongInt read FOrthoHeight;
    property PersWidth: single read FPersWidth;
    property PersHeight: single read FPersHeight;

    /// events

    property OnLastDraw: TOnDrawEvent read FOnLastDraw write FOnLastDraw;
    property OnFirstDraw: TOnDrawEvent read FOnFirstDraw write FOnFirstDraw;
    property OnDraw:TOnDrawProc read FOnDraw write FOnDraw;
    property OnFirstDrawProc: TOnDrawProc read FOnFirstDrawProc write FOnFirstDrawProc;


    // colors
    property Ambient: TARGB read FAmbient write SetAmbient;


    property ViewPort: TViewPort read FViewPort write SetViewPort;
    property Camera: TCamera read FCamera write SetCamera;
    property TextureMgr:TTextureMgr read FTextureMgr;

    property ClearColor: TARGB read FClearColor write FClearColor;
    property ClearZValue: single read FClearZVal write FClearZVal;
    property AutoClearTarget: boolean read FAutoClearTarget write
      FAutoClearTarget;
    property AutoClearZBuffer: boolean read FAutoClearZ write FAutoClearZ;
    property AutoPresent: boolean read FAutoPresent write FAutoPresent;

    property FullScreenModesCount:LongInt read GetModesCount;
    property FullScreenMode[Index:LongInt]:TFullScreenMode read GetMode;


  published



  end;

const
 sGEngineErr='Error in TGraphicEngine.';

implementation


uses DrawingEngines, GMessages, GfxMessages;


var GE: TGraphicEngine;



constructor TGraphicEngine.Create(AHwnd: THandle; AOwner: TEngine);
begin
  inherited Create(AOwner);

  if GE <> nil then
  begin
    GE.Free;
    GE := nil;
  end;

  GE := Self;

  Description := 'Graphic Rendering Engine';
  Updateperiod := 0;
  CreateRenderers;
  FPreferD3D := true;
  FHandle := AHwnd;
  FGfxParams := TRenderInitParams.Create;
  FBuffer := TDrawBuffer.Create;
  FViewPort := TViewPort.Create;
  FCamera := TCamera.Create;
  FTextureMgr:=TTextureMgr.Create();
  FModes:=TBaseMgr.Create;
  FPushView := TViewPort.Create;
  FPushCam := TCamera.Create;

  FFPS:=100;
  FFrames := 0;
  FLastTime := GetTimeMicroseconds;
  FClearColor := $FF303030;
  FClearZVal := 1;
  FAutoClearTarget := true;
  FAutoClearZ := true;
  FAutoPresent:=true;

 //////////////////////////////////////////  presets

  FgfxParams.Handle := 0;
  FgfxParams.Width := 800;
  FgfxParams.Height := 600;
  FgfxParams.ColorBits := 32;
  FgfxParams.DepthBits := 24;
  FgfxParams.StencilBits:=8;
  FgfxParams.RefreshRate:=0;
  FgfxParams.UseDepth := true;
  FgfxParams.BackBuffers := 1;
  FgfxParams.FullScreen := not true;
  FgfxParams.UseHardWare := true;
  FgfxParams.UseVSync :=  false;
  FgfxParams.UseHTL := true;
  FgfxParams.MultiSamples := 16;

 //////
  EnumFullScrModes;

    DefaultSets;


  Messages.AddHandler(MSG_GFX_RESET, 100, OnInitReset);
  Messages.AddHandler(MSG_GFX_INIT, 100, OnInitReset);
  Messages.AddHandler(MSG_GFX_WINDOWFREE, 100, OnWindowFree);





  PushCamera;
  PushViewPort;
  FPushFeat:=FeatureSet;
  FPushDWord:=DWordSet;
  FPushFloat:=FloatSet;

  if (not IsWindow(FHandle))then
  begin
    FWindow := TGfxWin.Create;
  end;

end;

destructor TGraphicEngine.Destroy;
begin
  Done;
  FModes.Free;
  FCamera.Free;
  FViewPort.Free;
  FBuffer.Free;
  FGfxParams.Free;
  FTextureMgr.Free;
  while DrawingEngines.DrawingEnginesMgr.Count>0 do
   DrawingEnginesMgr[0].Free;

  GE := nil;
  inherited Destroy;
end;

class function TGraphicEngine.GetInstance: TGraphicEngine;
begin
  if GE=nil then
   TGraphicEngine.Create();

  Result := GE;
end;


procedure TGraphicEngine.Init;
begin
  if FActiveRen = nil then
    FActiveRen := Renderers[0];

  if FActiveRen=nil then
   raise EGEngineErr.Create(sGEngineErr+'Init -  Active Renderer Not Registered (FActiveRen=nil)');

  if (FWindow <> nil) then
  begin
    FWindow.Init;
  end;

  SetActiveRenParams;
  FActiveRen.Init;


  FViewPort.Init;
  FCamera.Init;

  inherited Init;

  FRenderStart := 0;
  FFrames := 0;
  FSecFrames := 0;

  StopRendering;
end;

procedure TGraphicEngine.Done;
var I: LongInt;
begin
  inherited Done;
  FViewPort.Done;
  FCamera.Done;

  for I := 0 to DrawingEnginesMgr.Count - 1 do
    TDrawingEngine(DrawingEnginesMgr[I]).Done;

  TextureMgr.Clear;
  FActiveRen.Done;

end;

function TGraphicEngine.Reset: boolean;
begin
  Result := false;
  SetActiveRenParams;
  if not Inited then Exit;
  Result := FActiveRen.Reset;
end;


procedure TGraphicEngine.OnTimerEvent(Sender: TObject);
begin
  if Inited then TryUpdate;
end;

procedure TGraphicEngine.StopRendering;
begin
 Present;
 if Timer<>nil then
  Timer.Enabled:=false;
end;

procedure TGraphicEngine.ResumeRendering;
begin
// Present;
 if Timer<>nil then
  Timer.Enabled:=true;
end;

procedure TGraphicEngine.SetWithoutOwner;
begin
  inherited;
  Timer.Interval := 1;
  Timer.OnTimer := nil;
  Timer.OnTimer := OnTimerEvent;
  Timer.Enabled := false;
end;

procedure TGraphicEngine.SetRenParams(ARen: TRenderer);
begin
  if ARen = nil then Exit;


  GfxParams.CopyTo(ARen.Params);

  if OwnWindow then
  begin
    if FWindow <> nil then
      ARen.Params.Handle := FWindow.Handle
  end
  else
    ARen.Params.Handle := FHandle;


end;

procedure TGraphicEngine.SetActiveRenParams;
begin
  SetRenParams(ActiveRenderer);
end;

procedure TGraphicEngine.EnumFullScrModes;
begin
 FModes.Clear;
 if FActiveRen<>nil then
 FActiveRen.EnumFullScrModes(FModes);
end;

procedure TGraphicEngine.SetRen(Idx: LongInt; Value: TRenderer);
begin
 Objects[idx] := Value;
end;

function TGraphicEngine.GetRen(Idx: LongInt): TRenderer;
begin
  Result := TRenderer(Objects[idx]);
end;

procedure TGraphicEngine.SetWindow(Value: TGfxWin);
begin
  if Value = nil then Exit;
  if ActiveRenderer <> nil then
    if ActiveRenderer.Inited then Exit;

  if IsWindow(FHandle) then ;

  FWindow := Value;

end;

procedure TGraphicEngine.SetAmbient(Value: TARGB);
begin
  FAmbient := Value;
  if ActiveRenderer = nil then Exit;

  FActiveRen.SetDWord(sdAmbient, FAmbient);

end;

procedure TGraphicEngine.SetViewPort(Value: TViewPort);
begin
  FViewPort.Assign(Value);
end;

procedure TGraphicEngine.SetCamera(Value: TCamera);
begin
  FCamera.Assign(Value);
end;

function TGraphicEngine.Add(Ren: TRenderer): LongInt;
begin
  Result := -1;
  if Ren <> nil then
  begin
    Result := Objects.Add(Ren);
  end;

end;


procedure TGraphicEngine.CreateRenderers;
var I: LongInt;
begin
  for I := 0 to RegRenderers.Count - 1 do
  begin
    Add(TRendererInfo(RegRenderers[I]).Cls.Create);
    SetRenParams(Renderers[i]);
  end;

 FActiveRen:=Renderers[0];
end;


function TGraphicEngine.GetOwn: boolean;
begin
  Result := true;
  if IsWindow(FHandle) and (Window = nil) then Result := false;

end;


procedure TGraphicEngine.ChangeRenderer(ARen: TREnderer; InitNewRen: boolean);
begin
  if FActiveRen <> nil then
  begin
    if FActiveRen.Inited then
      FActiveRen.Done;
  end;

  FActiveRen := ARen;
  SetActiveRenParams;
  EnumFullScrModes;
  if InitNewRen then Init;
{ if not FActiveRen.Inited then
  FActiveRen.Init;}

end;

var
 st:TStringLIst;

procedure TGraphicEngine.Draw;
var I: LongInt;
begin
  if not Inited then Exit;
  if FActiveRen = nil then Exit;

  if FRenderStart = 0 then
    FRenderStart := GetTimeMicroSeconds;

  if FAutoClearTarget then
    ClearTarget(FClearColor);

  if FAutoClearZ then
    ClearZBuffer(FClearZVal);


  if Assigned(FOnFirstDraw) then FOnFirstDraw(Self);
  if Assigned(FOnFirstDrawProc) then FOnFirstDrawProc;

  for I := 0 to DrawingEnginesMgr.Count - 1 do
    TDrawingEngine(DrawingEnginesMgr[I]).Draw;

  if Assigned(FOnLastDraw) then FOnLastDraw(Self);
  if Assigned(FOnDraw) then FOnDraw;

  DrawStats;
  if FAutoPresent then
   Present;

  if st=nil then st:=tStringList.Create;
  st.Add(inttostr(factiveren.primsdrawn));
  factiveren.primsdrawn:=0;

end;

procedure TGraphicEngine.DrawStats;
var I: LongInt;
begin

  for I := 0 to DrawingEnginesMgr.Count - 1 do
    TDrawingEngine(DrawingEnginesMgr[I]).DrawStats;

  CalcFPS;
 // draw fps


end;

procedure TGraphicEngine.CalcFPS;
var T, T2: single;
begin
  T2 := GetTimeMicroSeconds;
  if (T2 - FLastSec) > 1000000 then
  begin
    FFPS := FSecFrames / (T2 - FLastSec) * 1000000;
    FLastSec := T2;
    FSecFrames := 0;
  end;
  T := T2 - FLastTime;
  FLastTime := T2;
  FActFPS:=1000000/T;
  Inc(FFrames);
  Inc(FSecFrames);
end;

function TGraphicEngine.GetAvgFPS: single;
begin
  Result := FFrames / (GetTimeMicroSeconds - FRenderStart) * 1000000;
end;


procedure TGraphicEngine.Update;
begin
  inherited;
  if Inited then Draw;
end;

function TGraphicEngine.GetRenByName(AName: string): TRenderer;
var I: LongInt;
begin
  Result := nil;
  for I := 0 to RenCount - 1 do
    if CompStr(Renderers[I].Name, AName) then
    begin
      Result := Renderers[I];
      Exit;
    end;


end;

function TGraphicEngine.GetRenCount;
begin
  Result := Objects.Count;
end;

function TGraphicEngine.GetModesCount:LongInt;
begin
 Result:=FModes.Count;
end;

function TGraphicEngine.GetMode(Idx:LongInt):TFullScreenMode;
begin
 Result:=nil;
 if not((Idx>-1)and(Idx<FModes.Count)) then Exit;
 Result:=TFullScreenMode(FModes[Idx]);

end;



procedure TGraphicEngine.Enable(F: TFeature);
begin
  FeatureSet[F]:=true;
  if not Inited then Exit;
  FActiveRen.Enable(F);

end;

procedure TGraphicEngine.Disable(F: TFeature);
begin
  FeatureSet[F]:=false;
  if not Inited then Exit;
  FActiveRen.Disable(F);

end;


function TGraphicEngine.IsSet(F: TFeature): boolean;
begin
  Result := FeatureSet[F];
end;

//////////////////////// projection

procedure TGraphicEngine.SetOrtho(Width, Height: LongInt);
begin
  FOrthoWidth := Iff(Width = 0, FOrthoWidth, Width);
  FOrthoHeight := Iff(Height = 0, FOrthoHeight, Height);

  if not Inited then Exit;

  if FActiveRen.SetOrtho(FOrthoWidth, FOrthoHeight) then
    FProjMode := pmOrthogonal;

end;

procedure TGraphicEngine.SetPerspective(Back, Fov: single);
begin
  FFov := Iff(Fov = 0, FFov, Fov);
  FBack := Iff(Back = 0, FBack, Back);

  if not Inited then Exit;

  if FActiveRen.SetPerspective(FFov, 0.1, FBack) then
    FProjMode := pmPerspective;


end;

procedure TGraphicEngine.SetPerspective(Back, Width, Height: single);
begin
{  FBack := Iff(Back = 0, FBack, Back);
  FPersWidth := Iff(Width = 0, FPersWidth, Width);
  FPersHeight := Iff(Height = 0, FPersHeight, Height);

  if not Inited then Exit;
  if FActiveRen.SetPerspective(FBack, (cos(FFOV / 2) / sin(FFOV / 2))) then
    FProjMode := pmPerspective;
 }
end;



procedure TGraphicEngine.SetProjMode(Value: TProjMode);
begin
  if not Inited then Exit;
  if FActiveRen <> nil then
    case Value of
      pmOrthogonal:
        if FActiveRen.SetOrtho(FOrthoWidth, FOrthoHeight) then
          FProjMode := Value;
      pmPerspective:
        if FActiveRen.SetPerspective(FFov, 0.1, FBack) then
          FProjMode := Value;
    end;

end;



function TGraphicEngine.ToggleFullScreen: boolean;
begin
  FGfxParams.FullScreen := not FActiveRen.UsedParams.FullScreen;
  Result := Reset;
end;

function TGraphicEngine.SetResolution(AWidth, AHeight: LongInt): boolean;
begin
  GfxParams.Width := AWidth;
  GfxParams.Height := AHeight;
  Result := Reset;
end;


function TGraphicEngine.SetResolution(AWidth, AHeight, ABits: LongInt; Full:
  boolean): boolean;
begin
  GfxParams.Width := AWidth;
  GfxParams.Height := AHeight;
  GfxParams.FullScreen := Full;
  GfxParams.ColorBits := ABits;
  Result := Reset;
end;


////////////////////////////////////
///////////////////////////////////
/// DRAW BUFFERS
///////////////////////////////////
///////////////////////////////////

procedure TGraphicEngine.CheckBuff;
  var VCount: LongInt;
  begin
    VCount := FActBuff.Points.Count;

    while FActBuff.Normals.Count < VCount do
      FActBuff.Normals.Add(nil);

    while FActBuff.Colors1.Count < VCount do
      FActBuff.Colors1.Add(nil);

    while FActBuff.Colors2.Count < VCount do
      FActBuff.Colors2.Add(nil);

    while FActBuff.Coords1.Count < VCount do
      FActBuff.Coords1.Add(nil);

    while FActBuff.Coords2.Count < VCount do
      FActBuff.Coords2.Add(nil);

  end;


function TGraphicEngine.DrawBegin(Mode: TDrawMode; Buff: TDrawBuffer): boolean;
begin
  Result := false;
  if not Inited then Exit;

  if Buff = nil then
    FActBuff := FBuffer
  else
    FActBuff := Buff;

  FActBuff.ClearAll;
  FActBuff.Ended := false;
  FActBuff.Mode := Mode;

  Result := true;

end;

function TGraphicEngine.DrawVertex(vX, vY, vZ: single): boolean;
var P: TPoint3S;
begin
  Result := false;
  if not Inited then Exit;
  P := Point3S(vX, vY, vZ);
  Result := DrawVertex(P);

end;

function TGraphicEngine.DrawVertex(vP: TPoint3S): boolean;
var PP: PPoint3S;
begin
  Result := false;
  if not Inited then Exit;
  GetMem(PP, SizeOf(TPoint3S));
  PP^ := vP;
  FActBuff.Points.Add(PP);
  CheckBuff;
  Result := true;

end;

function TGraphicEngine.DrawColor1(Color: TARGB): boolean;
var PC: PARGB;
begin
  Result := false;
  if not Inited then Exit;
  GetMem(PC, SizeOf(TARGB));
  PC^ := Color;
  FActBuff.Colors1.Add(PC);
  Result := true;

end;

function TGraphicEngine.DrawColor1(cA, cR, cG, cB: byte): boolean;
begin
  Result := false;
  if not Inited then Exit;
  Result := DrawColor1(ARGB(cA, cR, cG, cB));

end;

function TGraphicEngine.DrawColor1(cRec: TARGBRec): boolean;
begin
  Result := false;
  if not Inited then Exit;
  Result := DrawColor1(cRec.Color);

end;

function TGraphicEngine.DrawColor2(Color: TARGB): boolean;
var PC: PARGB;
begin
  Result := false;
  if not Inited then Exit;
  GetMem(PC, SizeOf(TARGB));
  FActBuff.Colors2.Add(PC);
  Result := true;

end;

function TGraphicEngine.DrawColor2(cA, cR, cG, cB: byte): boolean;
begin
  Result := false;
  if not Inited then Exit;
  Result := DrawColor2(ARGB(cA, cR, cG, cB));

end;

function TGraphicEngine.DrawColor2(cRec: TARGBRec): boolean;
begin
  Result := false;
  if not Inited then Exit;
  Result := DrawColor2(cRec.Color);

end;

function TGraphicEngine.DrawNormal(nX, nY, nZ: single): boolean;
begin
  Result := false;
  if not Inited then Exit;
  Result := DrawNormal(Point3S(nX, nY, nZ));


end;

function TGraphicEngine.DrawNormal(nP: TPoint3S): boolean;
var PN: PPoint3S;
begin
  Result := false;
  if not Inited then Exit;
  GetMem(PN, SizeOf(TPoint3S));
  PN^ := nP;
  FActBuff.Normals.Add(PN);
  Result := true;

end;

function TGraphicEngine.DrawCoord1(cX, cY: single): boolean;
begin
  Result := false;
  if not Inited then Exit;
  Result := DrawCoord1(Coord(cX, cY));


end;

function TGraphicEngine.DrawCoord1(cP: TPoint2S): boolean;
var PC: PTexCoord;
begin
  Result := false;
  if not Inited then Exit;
  GetMem(PC, SizeOf(TTexCoord));
  PC^ := cP;
  FActBuff.Coords1.Add(PC);
  Result := true;


end;

function TGraphicEngine.DrawCoord2(cX, cY: single): boolean;
begin
  Result := false;
  if not Inited then Exit;
  Result := DrawCoord2(Coord(cX, cY));

end;

function TGraphicEngine.DrawCoord2(cP: TPoint2S): boolean;
var PC: PTexCoord;
begin
  Result := false;
  if not Inited then Exit;
  GetMem(PC, SizeOf(TTexCoord));
  PC^ := cP;
  FActBuff.Coords2.Add(PC);
  Result := true;

end;

function TGraphicEngine.DrawCount(primcnt: LongInt): boolean;
begin
  Result := false;
  if not Inited then Exit;

  FActBuff.Primitives := primcnt;
  Result := true;
end;

function TGraphicEngine.DrawClear(Mode: TClearModes): boolean;
begin
  Result := false;
  if not Inited then Exit;
  if cmAll in Mode then
    FActBuff.ClearAll
  else
  begin
  end;
end;

function TGraphicEngine.DrawUse(used: TUsedFields): boolean;
begin
  Result := false;
  if not Inited then Exit;
  FActBuff.Used := Used;
  Result := true;
end;

function TGraphicEngine.DrawEnd(immediate: boolean): boolean;
begin
  Result := false;
  if not Inited then Exit;
  FActBuff.Ended := true;
  if Immediate then
    Result := DrawBuffer(FActBuff);

end;

function TGraphicEngine.DrawBuffer(Buff: TDrawBuffer): boolean;
begin
  Result := false;
  if not Inited then Exit;
  Result := FActiveRen.DrawBuffer(Buff);
end;

function TGraphicEngine.DrawTexture(Tex: TTexture): boolean;
begin
  Result := false;
  if not Inited then Exit;
  FActBuff.Texture := Tex;
  Result := true;

end;

function TGraphicEngine.DrawPoints(Points: array of TPoint3S): boolean;
var PP:PPoint3S;
    I:LongInt;
begin
  Result := false;
  if not Inited then Exit;

  for I:=Low(Points)to High(Points) do
  begin
  GetMem(PP, SizeOf(TPoint3S));
  PP^ := Points[I];
  FActBuff.Points.Add(PP);

  end;

  CheckBuff;
  Result := true;
end;

function TGraphicEngine.DrawPoints(Points: array of PPoint3S): boolean;
var PP:PPoint3S;
    I:LongInt;
begin
  Result := false;
  if not Inited then Exit;

  for I:=Low(Points)to High(Points) do
  begin
  GetMem(PP, SizeOf(TPoint3S));
  PP^ := Points[I]^;
  FActBuff.Points.Add(PP);

  end;

  CheckBuff;
  Result := true;
end;


function TGraphicEngine.DrawNormals(Norms: array of TPoint3S): boolean;
var I:longInt;
    PP:PPoint3S;
begin
  Result := false;
  if not Inited then Exit;

  for I:=Low(Norms)to High(Norms) do
  begin
  GetMem(PP, SizeOf(TPoint3S));
  PP^ := Norms[I];
  FActBuff.Normals.Add(PP);

  end;

  Result := true;
end;

function TGraphicEngine.DrawColors1(Cols: array of TARGB): boolean;
var I:LongInt;
    PP:PARGB;
begin
  Result := false;
  if not Inited then Exit;

  for I:=Low(Cols)to High(Cols) do
  begin
  GetMem(PP, SizeOf(TARGB));
  PP^ := Cols[I];
  FActBuff.Colors1.Add(PP);

  end;

  Result := true;
end;

function TGraphicEngine.DrawColors2(Cols: array of TARGB): boolean;
var I:LongInt;
    PP:PARGB;
begin
  Result := false;
  if not Inited then Exit;

  for I:=Low(Cols)to High(Cols) do
  begin
  GetMem(PP, SizeOf(TARGB));
  PP^ := Cols[I];
  FActBuff.Colors2.Add(PP);
  PP:=nil;
  end;

  Result := true;
end;

function TGraphicEngine.DrawCoords1(Coords: array of TTexCoord): boolean;
 var I:LongInt;
    PP:PTexCoord;
begin
  Result := false;
  if not Inited then Exit;

  for I:=Low(Coords)to High(Coords) do
  begin
  GetMem(PP, SizeOf(TTexCoord));
  PP^ := Coords[I];
  FActBuff.Coords1.Add(PP);
  PP:=nil;
  end;

  Result := true;
end;

function TGraphicEngine.DrawCoords2(Coords: array of TTexCoord): boolean;
var I:LongInt;
    PP:PTexCoord;
begin
  Result := false;
  if not Inited then Exit;

  for I:=Low(Coords)to High(Coords) do
  begin
  GetMem(PP, SizeOf(TTexCoord));
  PP^ := Coords[I];
  FActBuff.Coords2.Add(PP);
  PP:=nil;
  end;

  Result := true;
end;


procedure TGraphicEngine.NullSets;
begin
  ZeroMemory(@FeatureSet, SizeOf(FeatureSet));
  ZeroMemory(@DWordSet, SizeOf(DWordSet));
  ZeroMemory(@FloatSet, SizeOf(FloatSet));
end;

procedure TGraphicEngine.DefaultSets;
begin
  NullSets;
  FeatureSet[gfLighting] := true;
  FeatureSet[gfAlphaBlend] := true;
  FeatureSet[gfStencil] := false;
  FeatureSet[gfFog] := false;
  FeatureSet[gfDither] := true;
  FeatureSet[gfAlphaTest] := false;
  FeatureSet[gfClipPlanes] := false;
  FeatureSet[gfVertexColors] := true;
  FeatureSet[gfZWrite] := true;
  FeatureSet[gfNormalizeNormals] := false;
  FeatureSet[gfZBuffer] := true;

  DWordSet[sdAmbient] := $FFFFFFFF;
  DWordSet[sdCullMode] := CULL_CW;
  DWordSet[sdShadeMode] := SHADE_GOURAUD;
  DWordSet[sdFogColor] := $FFFFFFFF;
  DWordSet[sdFogMode] := FOG_LINEAR;
  DWordSet[sdTexFilter] := Textures.TextureFilter;
  DWordSet[sdZFunc] := CMP_LESSEQUAL;
  DWordSet[sdAlphaFunc] := CMP_ALWAYS;
  DWordSet[sdAlphaRef] := 0;
  DWordSet[sdStencilFunc] := CMP_ALWAYS;
  DWordSet[sdStencilRef] := 0;
  DWordSet[sdStencilMask] := $FFFFFFFF;
  DWordSet[sdFillMode] := FILL_SOLID;
  DWordSet[sdSrcBlend] := BLEND_SRCALPHA;
  DWordSet[sdDstBlend] := BLEND_INVSRCALPHA;
  DWordSet[sdTexAdrX] := TEXADR_WRAP;
  DWordSet[sdTexAdrY] := TEXADR_WRAP;

  FloatSet[sfFogStart] := 10000;
  FloatSet[sfFogEnd] := 15000;
  FloatSet[sfFogDensity] := 0.1;


end;

procedure TGraphicEngine.InitSets;
var F: TFeature;
  SD: TSetDWord;
  SF: TSetFloat;
begin
  for F := Low(TFeature) to High(TFeature) do
    if FeatureSet[F] then
      FActiveRen.Enable(F)
    else
      FActiveRen.Disable(F);

  for SD := Low(TSetDWord) to High(TSetDWord) do
    FActiveRen.SetDWord(SD, DWordSet[SD]);

  for SF := Low(TSetFloat) to High(TSetFLoat) do
    FActiveRen.SetFloat(SF, FloatSet[SF]);


end;

procedure TGraphicEngine.OnInitReset(MsgID: LongInt; Sender: TBaseObj; Data:
  Pointer);
begin
  InitSets;
  FCamera.UpdateView;
end;

procedure TGraphicEngine.OnWindowFree(MsgID: LongInt; Sender: TBaseObj; Data: Pointer);
begin
 Done;
end;

procedure TGraphicEngine.PushViewPort;
begin
FPushView.Assign(FViewPort);
end;

procedure TGraphicEngine.PushCamera;
begin
FPushCam.Assign(FCamera);
end;

procedure TGraphicEngine.PushFeatures;
begin
FPushFeat:=FeatureSet;
end;

procedure TGraphicEngine.PushDWords;
begin
FPushDWord:=DWordSet;
end;

procedure TGraphicEngine.PushFloats;
begin
FPushFloat:=FloatSet;
end;

procedure TGraphicEngine.PopViewPort;
begin
FViewPort.Assign(FPushView);
FViewPort.Reset;
FCamera.UpdateView;
end;

procedure TGraphicEngine.PopCamera;
begin
FCamera.Assign(FPushCam);
FCamera.UpdateView;
end;

procedure TGraphicEngine.PopFeatures(F:TFeatures);
var FF:TFeature;
begin
for FF:=Low(TFeature)to High(TFeature) do
 if FF in F then
  begin
  if FPushFeat[FF]then
   FActiveRen.Enable(FF)
   else
    FActiveRen.Disable(FF)
 end;

end;

procedure TGraphicEngine.PopDWords(D:TDWordModes);
var DD:TSetDWord;
begin
for DD:=Low(TSetDWord)to High(TSetDWord) do
 if DD in D then
  FActiveRen.SetDWord(DD,FPushDWord[DD]);


end;

procedure TGraphicEngine.PopFloats(F:TFloatModes);
var FF:TSetFLoat;
begin
for FF:=Low(TSetFloat)to High(TSetFloat) do
 if FF in F then
  FActiveRen.SetFloat(FF,FPushFloat[FF]);

end;




////////////////////////////////////
///////////////////////////////////
/// DRAWING FUNCTIONS
///////////////////////////////////
///////////////////////////////////

function TGraphicEngine.Present: boolean;
begin
  Result := false;
  if not Inited then Exit;
  if FActiveRen <> nil then
    if FActiveRen.Present then Result := true;

end;

function TGraphicEngine.ClearTarget(Color: TARGB): boolean;
begin
  Result := false;
  if not Inited then Exit;
  if FActiveRen.ClearTarget(Color) then
   Result := true;

end;

function TGraphicEngine.ClearZBuffer(Value: single): boolean;
begin
  Result := false;
  if not Inited then Exit;
  if FActiveRen.ClearZBuffer(Value) then
    FClearZVal := Value;
  Result := true;

end;


function TGraphicEngine.RenderPoint(Pos:TPoint3S;Col:TARGB):boolean;
begin
 DrawBegin(dmPoints);
 DrawColor1(Col);
 DrawVertex(Pos);
 Result:=DrawEnd;
end;


function TGraphicEngine.RenderLine(P1,P2:TPoint3S;Col:TARGB):boolean;
begin
 DrawBegin(dmLineList);
 DrawColor1(Col);
 DrawVertex(P1);
 DrawVertex(P2);
 DrawCount(1);
 Result:=DrawEnd;
end;

function TGraphicEngine.RenderLine(P1,P2:TPoint3S;Col1,Col2:TARGB):boolean;
begin
 DrawBegin(dmLineList);
 DrawColor1(Col1);
 DrawVertex(P1);
 DrawColor1(Col2);
 DrawVertex(P2);
 DrawCount(1);
 Result:=DrawEnd;
end;

function TGraphicEngine.RenderImage(X,Y:single;Img:TImage;MatchRes:boolean):boolean;
begin
 Result:=RenderImage(X,Y,Img.Width,Img.Height,Img,MatchRes);
end;

function TGraphicEngine.RenderImage(X,Y,Width,Height:single;Img:TImage;MatchRes:boolean):boolean;
var Tex:TTexture;
begin
Result:=false;
if not Inited then Exit;

Tex:=TTexture.Create(Img);
Result:=RenderTexture(X,Y,Width,Height,Tex,MatchRes);
Tex.Free;

end;

function TGraphicEngine.RenderTexture(X,Y:single;Tex:TTexture;MatchRes:boolean):boolean;
begin
 Result:=RenderTexture(X,Y,Tex.Width/Tex.ScaleXFactor,Tex.Height/Tex.ScaleYFactor,Tex,MatchRes);
end;


function TGraphicEngine.RenderTexture(X,Y,Width,Height:single;Tex:TTexture;MatchRes:boolean):boolean;
begin
 Result:=false;
 if not Inited then Exit;
 PushViewPort;
 PushFeatures;
 if MatchRes then
 FViewPort.Orthogonal(FActiveRen.UsedParams.Width,FActiveRen.UsedParams.Height)
 else
 FViewPort.ReOrthogonal;

 Disable(gfLighting);
 Disable(gfZBuffer);


 DrawBegin(dmTriangleStrip);
 DrawColor1($FFFFFFFF);
 DrawCoord1(0,0);
 DrawVertex(X,Y,0);
 DrawCoord1(1,0);
 DrawVertex(X+Width,Y,0);
 DrawCoord1(0,1);
 DrawVertex(X,Y+Height,0);
 DrawCoord1(1,1);
 DrawVertex(X+Width,Y+Height,0);
 DrawUse([ufColors1,ufCoords1,ufTexture]);
 DrawTexture(Tex);
 DrawCount(2);
 Result:=DrawEnd;

 PopFeatures([gfLighting,gfZBuffer]);
 PopViewPort;
end;

function TGraphicEngine.RenderRect(P1,P2:TPoint3S;Col:TARGB;Solid:boolean):boolean;
begin
 Result:=false;
 if not Inited then Exit;

if Solid then
 begin
 DrawBegin(dmTriangleStrip);
 DrawColor1(Col);
 DrawVertex(P1.X,P1.Y,P1.Z);
 DrawVertex(P2.X,P1.Y,(P1.Z+P2.Z)/2);
 DrawVertex(P1.X,P2.Y,(P1.Z+P2.Z)/2);
 DrawVertex(P2.X,P2.Y,P2.Z);
 DrawUse([ufColors1]);
 DrawCount(2);

 end
 else
 begin
 DrawBegin(dmLineStrip);
 DrawColor1(Col);
 DrawVertex(P1.X,P1.Y,P1.Z);
 DrawVertex(P2.X,P1.Y,(P1.Z+P2.Z)/2);
 DrawVertex(P2.X,P2.Y,P2.Z);
 DrawVertex(P1.X,P2.Y,(P1.Z+P2.Z)/2);
 DrawVertex(P1.X,P1.Y,P1.Z);
 DrawUse([ufColors1]);
 DrawCount(4);

 end;

 Result:=DrawEnd;


end;

function TGraphicEngine.RenderRect(X,Y,Width,Height:LongInt;Col:TARGB;Solid:boolean;MatchRes:boolean):boolean;
var View:TViewPort;
begin
 Result:=false;
 if not Inited then Exit;
 PushViewPort;
 PushFeatures;
 if MatchRes then
 FViewPort.Orthogonal(FActiveRen.UsedParams.Width,FActiveRen.UsedParams.Height)
 else
 FViewPort.ReOrthogonal;

Disable(gfLighting);
Disable(gfZBuffer);

 FActiveRen.SetTexture(nil);

 if Solid then
 begin
 DrawBegin(dmTriangleStrip);
 DrawColor1(Col);
 DrawVertex(X,Y,0);
 DrawVertex(X+Width,Y,0);
 DrawVertex(X,Y+Height,0);
 DrawVertex(X+Width,Y+Height,0);
 DrawUse([ufColors1]);
 DrawCount(2);

 end
 else
 begin
 DrawBegin(dmLineStrip);
 DrawColor1(Col);
 DrawVertex(X,Y,0);
 DrawVertex(X+Width,Y,0);
 DrawVertex(X+Width,Y+Height,0);
 DrawVertex(X,Y+Height,0);
 DrawVertex(X,Y,0);
 DrawUse([ufColors1]);
 DrawCount(4);

 end;

 Result:=DrawEnd;

 
 PopFeatures([gfLighting,gfZBuffer]);
 PopViewPort;

 end;


initialization


finalization
if st<>nil then
 st.SaveToFile('c:\project\tris.txt');


end.

