unit DynLights;

interface

uses Windows,SysUtils,Classes,WinUtils,BaseObjs,Objs3D,Types3D,Utils3D,
     Lights;

type


/// IMPORTANT NOTE

//  In OpenGL there is no Range ptoperty for Light
//  So do not Used TDynamicLight.Range. Instead
//  set QuadaticAttenuation to 1/Sqrt(DesiredRange) // using 1000 as max color value
//  this works same uder d3d and ogl and result is
//  nearly similar with using TDynLight.Range:=DesiredRange
//  (but this works only under D3D)

TDynamicLight = class(TLight)
private
 FIndex:LongInt;

 

 protected
  procedure SetActive(Value:boolean);override;
public
  constructor Create; override;
  destructor Destroy; override;

  procedure Init;override;
  procedure Done;override;
  procedure UpdateLight;override;
  procedure FreeLight;virtual;

  property Index:LongInt read FIndex write FIndex; 

published

end;


const

 MAX_DYN_LIGHTS=8;

implementation

uses GGraphic;

var
  // Add DynLights Manager
  // this down here is baleful

  LastIdx:LongInt=0;

function GetIndex:LongInt;
begin
 Result:=LastIdx;
 Inc(LastIdx);
end;

procedure FreeIdx;
begin
 Dec(lastIdx);
end;

constructor TDynamicLight.Create;
begin
 inherited Create;
 FIndex:=-1;

end;

destructor TDynamicLight.Destroy;
begin
 Done;
 inherited Destroy;
end;

procedure TDynamicLight.Init;
begin
 inherited Init;
end;

procedure TDynamicLight.Done;
begin
 inherited Done;
 FreeLight;
end;

procedure TDynamicLight.UpdateLight;
begin
 if not Inited then Exit;
 if FIndex=-1 then
  FIndex:=GetIndex;
 Renderer.CreateLight(Self);
 Renderer.EnableLight(FIndex);

end;

procedure TDynamicLight.FreeLight;
begin
 Renderer.DisableLight(FIndex);
 FreeIdx;
 FIndex:=-1;

end;

procedure TDynamicLight.SetActive(Value:boolean);
begin
 if Active<>Value then
 begin
  if not Value then
   Done
  else
   Init;
 end;
 inherited SetActive(Value);
end;



end.
