unit PortalEngine;

interface

uses Windows,SysUtils,Classes,WinUtils,BaseObjs,Objs3D,Types3D,
     Utils3D,Colors,Textures,BaseMgrs,Engines,PortalRoot,ContNRS,
     Sectors,Points,Faces,Walls;

type


  TPortalEngine = class(TEngine)
  private
   FPoints:TObjectList;
   FRoot:TPortalRoot;


  protected

  public
    constructor Create(AOwner:TEngine=nil); override;
    destructor Destroy; override;

    procedure Init;override;
    procedure Done;override;

    class function GetInstance:TPortalEngine;


    function AddSector(AName:string):TSector;
    function AddPoint(P:TFacePoint):TFacePoint;

  published

  end;


implementation

uses GScene;

var PE:TPortalEngine;

constructor TPortalEngine.Create(AOwner:TEngine);
begin
 inherited Create;
 FRoot:=TPortalRoot.Create;
 FPoints:=TObjectList.Create;

end;

destructor TPortalEngine.Destroy;
begin
 Done;

 FRoot.Free;
 inherited Destroy;
end;

procedure TPortalEngine.Init;
begin
 inherited Init;
 Scene.Root.AddChild(FRoot);

end;

procedure TPortalEngine.Done;
begin

 if Scene<>nil then
  Scene.Root.ChildMgr.Extract(FRoot);
 inherited Done;
end;

class function TPortalEngine.GetInstance:TPortalEngine;
begin
if PE = nil then
  begin
    PE := TPortalEngine.Create();
  end;
  Result := PE;
end;

function TPortalEngine.AddSector(AName:string):TSector;
var S:TSector;
begin
 S:=TSector.Create;
 S.Name:=AName;
 Result:=S;
 FRoot.AddChild(S);
end;

function TPortalEngine.AddPoint(P:TFacePoint):TFacePoint;
begin
 if P=nil then Exit;
 Result:=P;
 FPoints.Add(P);
end;



end.
