unit Sectors;

interface

uses Windows,SysUtils,Classes,WinUtils,BaseObjs,Objs3D,Types3D,
     Utils3D,Colors,Textures,BaseMgrs,Walls;

type

        TSector=class(TBase3DObj)
        private
         FWalls:TWallMgr;
         FPortals:TWallMgr;
         FFloor:TWall;
         FCeil:TWall;

           // for setting texture/color of all walls at once
         FTexture:TTexture;
         FColor:TARGB;

        protected

         procedure SetTexture(Value:TTexture);virtual;
         procedure SetColor(Value:TARGB);virtual;

        public

          constructor Create; override;
          destructor Destroy; override;

          procedure Init;override;
          procedure Done;override;

          procedure Draw;override;

          function AddWall(W:TWall):TWall;

          property Texture:TTexture read FTexture write SetTexture;
          property Color:TARGB read FColor write SetColor;
          property Walls:TWallMgr read FWalls;

        published

        end;




implementation

constructor TSector.Create;
begin
 inherited Create;
 FWalls:=TWallMgr.Create();
 FPortals:=TWallMgr.Create();


end;

destructor TSector.Destroy;
begin


 FWalls.Free;
 FPortals.Free;
 FFloor.Free;
 FCeil.Free;
 inherited Destroy;
end;

procedure TSector.Init;
begin

 inherited Init;
end;

procedure TSector.Done;
begin

 inherited Done;
end;

procedure TSector.SetTexture(Value:TTexture);
var I:LongInt;
begin
 FTexture:=Value;

 for I:=0 to FWalls.Count-1 do
  FWalls[I].Texture:=FTexture;
end;

procedure TSector.SetColor(Value:TARGB);
var I:LongInt;
begin
 FColor:=Value;

 for I:=0 to FWalls.Count-1 do
  FWalls[I].Color:=FColor;
end;

procedure TSector.Draw;
var I:LongInt;
begin
 for I:=0 to FWalls.Count-1 do
  FWalls[I].Draw;

end;

function TSector.AddWall(W:TWall):TWall;
begin
 FWalls.Add(W);
 Result:=W;
end;

end.
