unit Lighting;

interface

uses Windows,SysUtils,Classes,WinUtils,BaseObjs,Objs3D,Types3D,
     Utils3D,Colors,Textures,BaseMgrs;

type

     TLighting=class(TBaseObj)
     private
      FAmbient:TARGB;
      FEnabled:boolean;

     protected

      procedure SetAmbient(Value:TARGB);
      procedure SetEnabled(Value:boolean);

     public
       constructor Create; override;
       destructor Destroy; override;

       procedure Init;override;

       procedure Assign(Source:TBaseObj);override;

       property Ambient:TARGB read FAmbient write SetAmbient;
       property Enabled:boolean read FEnabled write SetEnabled;

     published

     end;



implementation

uses GGraphic,GfxTypes;

constructor TLighting.Create;
begin
 inherited Create;
 FAmbient:=$FFFFFFFF;
 FEnabled:=true;

end;

destructor TLighting.Destroy;
begin

 inherited Destroy;
end;

procedure TLighting.Init;
begin
 inherited Init;
 SetAmbient(FAmbient);
 SetEnabled(FEnabled);
end;

procedure TLighting.Assign(Source:TBaseObj);
var L:TLighting;
begin
inherited Assign(Source);
 if not(Source is TLighting) then Exit;
 L:=TLighting(Source);

 Enabled:=L.Enabled;
 Ambient:=L.Ambient;
end;

procedure TLighting.SetAmbient(Value:TARGB);
begin
 FAmbient:=Value;
 if Inited then
  Graphic.Ambient:=FAmbient;

end;

procedure TLighting.SetEnabled(Value:boolean);
begin
 FEnabled:=Value;
 if Inited then
  begin
  if FEnabled then
  Graphic.Enable(gfLighting)
  else
  Graphic.Disable(gfLighting)
  end;

end;



end.
