unit ImgBMP;

interface

uses Windows,SysUtils,Classes,WinUtils,BaseObjs,DIB,Images
  ,Graphics;


function LoadBMP(Path:string;Stream:TStream;Loc:TImgLoc):TDIB;
procedure SaveBMP(DIB:TDIB;Path:string;Stream:TStream;Loc:TImgLoc);


const

 Desc='Bitmap Image';

var

 BMPSaveEncoded:boolean=true;

implementation

function LoadBMP(Path:string;Stream:TStream;Loc:TImgLoc):TDIB;
var DIB:TDIB;
begin

try

DIB:=TDIB.Create;

case Loc of
ilFile:DIB.LoadFromFile(Path);
ilStream:DIB.LoadFromStream(Stream);
end;

except
 raise Exception.Create('ImgBMP.pas - Error in LoadBMP');

end;


Result:=DIB;

end;

procedure SaveBMP(DIB:TDIB;Path:string;Stream:TStream;Loc:TImgLoc);
begin

try

 if BMPSaveEncoded then DIB.Compress;

case Loc of
ilFile:DIB.SaveToFile(Path);
ilStream:DIB.SaveToStream(Stream);
end;


except
 raise Exception.Create('ImgBMP.pas - Error in SaveBMP');
end;



end;



initialization

Images.RegisterImgFormat(['.bmp','.dib'],Desc,LoadBMP,SaveBMP);

finalization


end.
