unit ImgJPG;

interface

uses Windows,SysUtils,Classes,WinUtils,BaseObjs,Images,DIB
  ,JPEG,Graphics;


function LoadJPG(Path:string;Stream:TStream;Loc:TImgLoc):TDIB;
procedure SaveJPG(DIB:TDIB;Path:string;Stream:TStream;Loc:TImgLoc);


const

 Desc='JPEG Image';

var JPEGSaveQuality:byte=90;


implementation

function LoadJPG(Path:string;Stream:TStream;Loc:TImgLoc):TDIB;
var JPG:TJPEGImage;
    DIB:TDIB;
begin

try

JPG:=TJPEGImage.Create;
case Loc of
ilFile:JPG.LoadFromFile(Path);
ilStream:JPG.LoadFromStream(Stream);
end;

DIB:=TDIB.Create;
DIB.Assign(JPG);
JPG.Free;

except
 raise Exception.Create('ImgJPG.pas - Error in LoadJPG');

end;


Result:=DIB;




end;

procedure SaveJPG(DIB:TDIB;Path:string;Stream:TStream;Loc:TImgLoc);
var JPG:TJPEGImage;
    BMP:TBitmap;
begin

try
 JPG:=TJPEGImage.Create;

 BMP:=TBitmap.Create;
 BMP.Width:=DIB.Width;
 BMP.Height:=DIB.Height;
 BMP.PixelFormat:=pf24bit;
 BMP.Canvas.Draw(0,0,DIB);
 JPG.Assign(BMP);
 JPG.CompressionQuality:=JPEGSaveQuality;


case Loc of
ilFile:JPG.SaveToFile(Path);
ilStream:JPG.SaveToStream(Stream);
end;

 BMP.Free;
 JPG.Free;

except
 raise Exception.Create('ImgJPG.pas - Error in SaveJPG');
end;



end;



initialization

Images.RegisterImgFormat(['.jpg','.jpeg','.jfif'],Desc,LoadJPG,SaveJPG);

finalization


end.
