unit ImgTGA;


interface

uses Windows,SysUtils,Classes,WinUtils,BaseObjs,Images,DIB
  ,TGAImage,Graphics;


function LoadTGA(Path:string;Stream:TStream;Loc:TImgLoc):TDIB;
procedure SaveTGA(DIB:TDIB;Path:string;Stream:TStream;Loc:TImgLoc);


const

 Desc='TGA Image';


implementation

function LoadTGA(Path:string;Stream:TStream;Loc:TImgLoc):TDIB;
var TGA:TTGAImage;
    DIB:TDIB;
begin

try

TGA:=TTGAImage.Create;
case Loc of
ilFile:TGA.LoadFromFile(Path);
ilStream:TGA.LoadFromStream(Stream);
end;

DIB:=TDIB.Create;
DIB.Assign(TGA.Image.DIB);
TGA.Free;

except
 raise Exception.Create('ImgTGA.pas - Error in LoadTGA');

end;


Result:=DIB;

end;

procedure SaveTGA(DIB:TDIB;Path:string;Stream:TStream;Loc:TImgLoc);
var TGA:TTGAImage;
begin

try
 TGA:=TTGAImage.Create;

 TGA.Assign(DIB);
case Loc of
ilFile:TGA.SaveToFile(Path);
ilStream:TGA.SaveToStream(Stream);
end;

 TGA.Free;

except
 raise Exception.Create('ImgTGA.pas - Error in SaveTGA');
end;



end;



initialization

Images.RegisterImgFormat(['.tga'],Desc,LoadTGA,SaveTGA);

finalization


end.

