unit TexUtils;

interface

uses Windows,SysUtils,Classes,WinUtils,BaseObjs,Textures,Images,Colors,ImgUtils,
     Renderers;


procedure ConvertARGB8ToARGB4(W,H:LongInt;Src:Pointer; Dest:Pointer);
procedure ConvertARGB8ToA1RGB5(W,H:LongInt;Src:Pointer; Dest:Pointer);
procedure SwapRGB32(W,H:LongInt;Dest:Pointer);
procedure SwapRGB24(W,H:LongInt;Dest:Pointer);
procedure SetColorKey32(W,H:LongInt;Key:TARGB;Dest:Pointer);

implementation


procedure ConvertARGB8ToARGB4(W,H:LongInt;Src:Pointer; Dest:Pointer);
var pw:pWord;
    pd:PDWord;
    col:DWord;
    x,y:LongInt;
begin
 pW:=Dest;
 pD:=Src;

 for x:=1 to W do
  for y:=1 to H do
   begin
    col:=pD^;
        pw^:=(((col shr 28) and $F) shl 12) or
            (((col shr 20) and $F) shl 8) or
            (((col shr 12) and $F) shl 4) or
            ((col shr 4) and $F);
    inc(pw);
    inc(pD);
   end;
end;

procedure ConvertARGB8ToA1RGB5(W,H:LongInt;Src:Pointer; Dest:Pointer);
var pw:pWord;
    pargb:PARGBRec;
    col:DWord;
    x,y:LongInt;
begin
 pW:=Dest;
 pargb:=Src;

 for x:=1 to W do
  for y:=1 to H do
   begin
    col:=(pargb^.a shl 24)or(pargb^.r shl 16) or (pargb^.g shl 8) or pargb^.b;
    if col=0 then
    pW^:=0
     else
    pw^:=(  (1 shl 15) or
            ((col shr 19) and $1F) shl 10) or
            (((col shr 11) and $1F) shl 5) or
            ((col shr 3) and $1F);
    inc(pw);
    inc(pargb);
   end;
end;

procedure SetColorKey32(W,H:LongInt;Key:TARGB;Dest:Pointer);
var pD:PARGBRec;
    KeyRec:TARGBRec;
    x,y:LongInt;
begin
 pD:=Dest;
 KeyRec:=ARGBRec(Key);

 for x:=1 to W do
  for y:=1 to H do
   begin
    if (pD^.R =KeyRec.R)and
       (pD^.G =KeyRec.G)and
       (pD^.B =KeyRec.B)then
      pD^.Color:=0;
    Inc(pD);
   end;
end;



procedure SwapRGB32(W,H:LongInt;Dest:Pointer);
var
  Col:PARGBRec;
  b:byte;
  x,y:LongInt;
begin
 Col:=Dest;

 for x:=0 to W-1 do
  for y:=0 to H-1 do
   begin
    b:=Col.R;
    Col.R:=Col.B;
    Col.B:=b;
    Inc(Col);
   end;


end;

procedure SwapRGB24(W,H:LongInt;Dest:Pointer);
var
  Col:PRGBRec;
  b:byte;
  x,y:LongInt;
begin
 Col:=Dest;
 for x:=0 to W-1 do
  for y:=0 to H-1 do
   begin
    b:=Col.R;
    Col.R:=Col.B;
    Col.B:=b;
    Inc(Col);
   end;

end;


end.
